/*******************************************************************************
 * Copyright (c) 2013, 2020 Willink Transformations and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.qvtd.xtext.qvtimperativecs;

import org.eclipse.emf.ecore.EFactory;
import org.eclipse.jdt.annotation.NonNull;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.qvtd.xtext.qvtimperativecs.QVTimperativeCSPackage
 * @generated
 */
public interface QVTimperativeCSFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	QVTimperativeCSFactory eINSTANCE = org.eclipse.qvtd.xtext.qvtimperativecs.impl.QVTimperativeCSFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Add Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Add Statement CS</em>'.
	 * @generated
	 */
	@NonNull AddStatementCS createAddStatementCS();

	/**
	 * Returns a new object of class '<em>Append Parameter Binding CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Append Parameter Binding CS</em>'.
	 * @generated
	 */
	@NonNull AppendParameterBindingCS createAppendParameterBindingCS();

	/**
	 * Returns a new object of class '<em>Append Parameter CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Append Parameter CS</em>'.
	 * @generated
	 */
	@NonNull AppendParameterCS createAppendParameterCS();

	/**
	 * Returns a new object of class '<em>Buffer Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Buffer Statement CS</em>'.
	 * @generated
	 */
	@NonNull BufferStatementCS createBufferStatementCS();

	/**
	 * Returns a new object of class '<em>Check Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Check Statement CS</em>'.
	 * @generated
	 */
	@NonNull CheckStatementCS createCheckStatementCS();

	/**
	 * Returns a new object of class '<em>Declare Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Declare Statement CS</em>'.
	 * @generated
	 */
	@NonNull DeclareStatementCS createDeclareStatementCS();

	/**
	 * Returns a new object of class '<em>Direction CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Direction CS</em>'.
	 * @generated
	 */
	@NonNull DirectionCS createDirectionCS();

	/**
	 * Returns a new object of class '<em>Entry Point CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Entry Point CS</em>'.
	 * @generated
	 */
	EntryPointCS createEntryPointCS();

	/**
	 * Returns a new object of class '<em>Guard Parameter Binding CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Guard Parameter Binding CS</em>'.
	 * @generated
	 */
	@NonNull GuardParameterBindingCS createGuardParameterBindingCS();

	/**
	 * Returns a new object of class '<em>Guard Parameter CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Guard Parameter CS</em>'.
	 * @generated
	 */
	@NonNull GuardParameterCS createGuardParameterCS();

	/**
	 * Returns a new object of class '<em>Loop Parameter Binding CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Loop Parameter Binding CS</em>'.
	 * @generated
	 */
	@NonNull LoopParameterBindingCS createLoopParameterBindingCS();

	/**
	 * Returns a new object of class '<em>Mapping CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mapping CS</em>'.
	 * @generated
	 */
	@NonNull MappingCS createMappingCS();

	/**
	 * Returns a new object of class '<em>Mapping Call CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mapping Call CS</em>'.
	 * @generated
	 */
	@NonNull MappingCallCS createMappingCallCS();

	/**
	 * Returns a new object of class '<em>Mapping Loop CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mapping Loop CS</em>'.
	 * @generated
	 */
	@NonNull MappingLoopCS createMappingLoopCS();

	/**
	 * Returns a new object of class '<em>Param Declaration CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Param Declaration CS</em>'.
	 * @generated
	 */
	@NonNull ParamDeclarationCS createParamDeclarationCS();

	/**
	 * Returns a new object of class '<em>Query CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Query CS</em>'.
	 * @generated
	 */
	@NonNull QueryCS createQueryCS();

	/**
	 * Returns a new object of class '<em>New Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>New Statement CS</em>'.
	 * @generated
	 */
	@NonNull NewStatementCS createNewStatementCS();

	/**
	 * Returns a new object of class '<em>Set Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Statement CS</em>'.
	 * @generated
	 */
	@NonNull SetStatementCS createSetStatementCS();

	/**
	 * Returns a new object of class '<em>Simple Parameter Binding CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Simple Parameter Binding CS</em>'.
	 * @generated
	 */
	@NonNull SimpleParameterBindingCS createSimpleParameterBindingCS();

	/**
	 * Returns a new object of class '<em>Simple Parameter CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Simple Parameter CS</em>'.
	 * @generated
	 */
	@NonNull SimpleParameterCS createSimpleParameterCS();

	/**
	 * Returns a new object of class '<em>Speculate Statement CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Speculate Statement CS</em>'.
	 * @generated
	 */
	SpeculateStatementCS createSpeculateStatementCS();

	/**
	 * Returns a new object of class '<em>Top Level CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Top Level CS</em>'.
	 * @generated
	 */
	@NonNull TopLevelCS createTopLevelCS();

	/**
	 * Returns a new object of class '<em>Transformation CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Transformation CS</em>'.
	 * @generated
	 */
	@NonNull TransformationCS createTransformationCS();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	QVTimperativeCSPackage getQVTimperativeCSPackage();

} //QVTimperativeCSTFactory
